﻿B4A=true
Group=Default Group
ModulesStructureVersion=1
Type=Activity
Version=9.801
@EndOfDesignText@
#Region  Activity Attributes 
	#FullScreen: False
	#IncludeTitle: False
#End Region

Sub Process_Globals
	'These global variables will be declared once when the application starts.
	'These variables can be accessed from all modules.
	Dim Power_Interface_layout, Action_Command As Boolean
	Dim temp_Control As Double
	Dim SetMax As Double
	
End Sub

Sub Globals
	'These global variables will be redeclared each time the activity is created.
	'These variables can only be accessed from this module.
	
	Private CircularSeekBar1 As CircularSeekBar
	Private B4XSwitch1 As B4XSwitch
	Private Image_heat As B4XView
	Private Btn_save_Temp As B4XView
	
	Private file_Setup As String=""
	Dim cs As CSBuilder
	Private Actif_save  As Boolean=False
	Dim xui As XUI
	Private RoundSlider1 As RoundSlider
	Private JSON_file_Setup As String
	
End Sub

Sub Activity_Create(FirstTime As Boolean)
	'Do not forget to load the layout file created with the visual designer. For example:
	'Activity.LoadLayout("Layout1")
	Activity.LoadLayout("power_control")
	SetMax=30
	CircularSeekBar1.MaxValue=20
	CircularSeekBar1.Offsets=10
	CircularSeekBar1.Sweep_Scale=0.5
	CircularSeekBar1.Touch_Scale=0.1
	
	file_Setup=Main.Localisation_Home & "_" & "setup.txt"
	JSON_file_Setup = Main.Localisation_Home & "_" & "setup.json"
	
	Dim bitmap As Bitmap
						
	If Cockpit.LiveTemp="100" Then 'Bloque le réglage si la température Live n'est pas remontée
		CircularSeekBar1.Enable=False
	Else
		CircularSeekBar1.Enable=True
	End If
	
	bitmap.Initialize(File.DirAssets,"heat1.png")
		
	bitmap= bitmap.Resize(Image_heat.Width,Image_heat.Height,True)
	Image_heat.SetBitmap(bitmap)
	
	'Ennumeration avec Json
	
	'JSON_file_Setup = Main.Localisation_Home & "_" & "setup.json"
	
	'wait for (Param.Read_JSONfile(JSON_file_Setup)) complete  (result As Boolean)
		
	Dim MapDataSensor As Map
			
		
	For Each L_Map As Map In Cockpit.SetupReadJsonList
					
		MapDataSensor= L_Map.Get(L_Map.GetKeyAt(0))
			
		If Cockpit.Macaddress= MapDataSensor.Get("SensorMacAddress") Then
			
			If  MapDataSensor.get("SetTemp")<>"" Then
				CircularSeekBar1.Value=MapDataSensor.get("SetTemp")-CircularSeekBar1.Offsets
				SetMax=MapDataSensor.get("MaxTemp")
				
			End If
			
		End If
	Next
	
	If CircularSeekBar1.Value > Cockpit.LiveTemp Then
		HeatPicture(True)
	Else
		HeatPicture(False)
	End If
	
		
End Sub

Sub HeatPicture(HeatActif As Boolean)
	
	Dim bitmap As Bitmap
						
	If HeatActif=True Then
		bitmap.Initialize(File.DirAssets,"heat.png")
	Else
		bitmap.Initialize(File.DirAssets,"heat1.png")
	End If
	
		
	bitmap= bitmap.Resize(Image_heat.Width,Image_heat.Height,True)
	Image_heat.SetBitmap(bitmap)
	
End Sub

Sub Activity_Resume
	Power_Interface_layout=True
End Sub

Sub Activity_Pause (UserClosed As Boolean)
	Power_Interface_layout=False
End Sub

Sub B4XSwitch1_ValueChanged (Value As Boolean)
	
'	If B4XSwitch1.Value=True Then
'		CircularSeekBar1.Enable=True
'		Btn_save_Temp.Enabled=True
'	Else
'		CircularSeekBar1.Enable=False
'		Btn_save_Temp.Enabled=False
'	End If
	
End Sub

Sub Save_Power_Parameter
	
	Dim MapDataSensor As Map
	Setup_Power_connected.Action_Command=False

	For Each L_Map As Map In Cockpit.SetupReadJsonList
		MapDataSensor= L_Map.Get(L_Map.GetKeyAt(0))
		If Cockpit.Macaddress= MapDataSensor.Get("SensorMacAddress") Then
				
			MapDataSensor.Put("SetTemp",temp_Control) ' Set Temp
			MapDataSensor.Put("@SetTemp",temp_Control) ' Set Temp
						
		End If
	Next
	
	Dim jg As JSONGenerator
	jg.Initialize2(Cockpit.SetupReadJsonList)
	
	wait for (Param.Write_Json_File(JSON_file_Setup,jg.ToPrettyString(4)))complete (result As Boolean)
	
	

	
	'Mise à jour du fichier  et Sauvegarde dans le Cloud
	wait for (Param.write_file_setup(Main.list_Read_Setup, file_Setup,False,False)) complete (result As Boolean)
	
	If IsPaused(Transfert_Server)=True Then
		'Lbl_info_transfert.Visible=True
		Main.type_transfert=Cockpit.Upload_File_HH
		StartService(Transfert_Server)
	End If
	
End Sub

Sub Activity_KeyPress (KeyCode As Int) As Boolean 'return true if you want to consume the event
    
		
	Select KeyCode
		Case KeyCodes.KEYCODE_VOLUME_UP
			Log("Up")
			Return True
					
		Case KeyCodes.KEYCODE_VOLUME_DOWN
			Log("Down")
			Return True
		Case KeyCodes.KEYCODE_BACK
			
			If Actif_save=False And Action_Command=False Then
				Return False
			Else
				
				ToastMessageShow("Veuillez patienter...",True)
				Return True
			End If
		
	End Select
End Sub


Sub Btn_save_Temp_Click
	Actif_save=True
	Btn_save_Temp.TextColor=Colors.Yellow
	
	temp_Control= Round2(CircularSeekBar1.Value,1)' $"$1.1{CircularSeekBar1.Value}"$
	Save_Power_Parameter
End Sub

Sub result_transfert_upload(success As Boolean)
	
	If success=False Then
		Btn_save_Temp.TextColor=Colors.Red
	Else
		Btn_save_Temp.TextColor=Colors.Green
		Actif_save=False
	End If
	
	'******************* Mis en commentaire pour ne pas attendre le retour de la commande
	
	Dim sf As Object = xui.Msgbox2Async("Souhaitez-vous mettre à jour maintenant ou attendre la prochaine mesure ?", "Mise à jour", "Mettre à jour", "", "Attendre", Null)
	Wait For (sf) Msgbox_Result (Result1 As Int)
	If Result1 = xui.DialogResponse_Positive Then
				
		' lance une commande de lecture avec les nouveaux paramètres
		
		file_Setup= Main.Localisation_Home & "_" & "command.txt"
		Actif_save=False
		Action_Command=True
		Main.list_Read_Cde.Clear
		Main.list_Read_Cde.Add("[ControlPower]")
		
		wait for (Param.write_file_setup(Main.list_Read_Cde, file_Setup,False,False)) complete (Result As Boolean)
		Sleep(2000)
			
		If IsPaused(Transfert_Server)=True Then
			'Lbl_info_transfert.Visible=True
			Main.type_transfert=Cockpit.Upload_File_HH
			StartService(Transfert_Server)
		End If
				
'		Setup_Power_connected.Update_data_sensor_enable=True 'Provoque la vérif sur le serveur toutes les 10s
'		Cockpit.Timer1.Enabled=True
'	
'		If Cockpit.Timer2.Enabled=False Then 'Active l'icone de contrôle de nouvelles données sur le serveur
'			Cockpit.Timer2.Enabled=True
'		End If
	Else If Result1 = xui.DialogResponse_negative Then
		Actif_save=False
	End If
	
		
	file_Setup=Main.Localisation_Home & "_" & "setup.txt"

End Sub

