﻿B4A=true
Group=Default Group
ModulesStructureVersion=1
Type=Activity
Version=10.7
@EndOfDesignText@
#Region  Activity Attributes 
	#FullScreen: False
	#IncludeTitle: false
#End Region

Sub Process_Globals
	'These global variables will be declared once when the application starts.
	'These variables can be accessed from all modules.

End Sub

Sub Globals
	'These global variables will be redeclared each time the activity is created.
	'These variables can only be accessed from this module.

	Private DateTemplate As B4XDateTemplate
	Private Dialog As B4XDialog
	
	Private xui As XUI
	Private BtnCalendar As B4XView
	Private xChartHeat As xChart
	Private xChartSensor As xChart
	Private ASTabMenu1 As ASTabMenu
	Private ASViewPager1 As ASViewPager
	Private ASTabStrip1 As ASTabStrip
	Private LblLocStat As B4XView
End Sub

Sub Activity_Create(FirstTime As Boolean)
	'Do not forget to load the layout file created with the visual designer. For example:
	'Activity.LoadLayout("Layout1")


	Activity.LoadLayout("StatTemp")
	
	'Création du TAB avec chargement des layouts
	
	ASTabStrip1.Initialize(ASTabMenu1,ASViewPager1)
	
	'Tab Stat Day
	Dim tmp_xpnl As B4XView = xui.CreatePanel("")
	tmp_xpnl.Color = xui.Color_Transparent
	tmp_xpnl.SetLayoutAnimated(0,0,0,ASViewPager1.CustomListView.GetBase.Width,ASViewPager1.CustomListView.GetBase.Height)
	Dim Icon As B4XBitmap= ASTabMenu1.FontToBitmap(Chr(0xE6E1),True,30,xui.Color_White)
	ASTabStrip1.AddPage(xui.Color_ARGB(255,0, 174, 255),"Stat jour",Icon,"",tmp_xpnl,"")
	tmp_xpnl.LoadLayout("StatTempDay")
	LblLocStat.Text=Cockpit.Local_sensor
	' Tab Stat Week
	Dim tmp_xpnl As B4XView = xui.CreatePanel("")
	tmp_xpnl.Color = xui.Color_Transparent
	tmp_xpnl.SetLayoutAnimated(0,0,0,ASViewPager1.CustomListView.GetBase.Width,ASViewPager1.CustomListView.GetBase.Height)
	Dim Icon As B4XBitmap= ASTabMenu1.FontToBitmap(Chr(0xE6E1),True,30,xui.Color_White)
	ASTabStrip1.AddPage(xui.Color_ARGB(255,0, 174, 255),"Stat semaine",Icon,"",tmp_xpnl,"")
	tmp_xpnl.LoadLayout("StatTempDay")
	LblLocStat.Text=Cockpit.Local_sensor
	'Tab Stat Month
	Dim tmp_xpnl As B4XView = xui.CreatePanel("")
	tmp_xpnl.Color = xui.Color_Transparent
	tmp_xpnl.SetLayoutAnimated(0,0,0,ASViewPager1.CustomListView.GetBase.Width,ASViewPager1.CustomListView.GetBase.Height)
	Dim Icon As B4XBitmap= ASTabMenu1.FontToBitmap(Chr(0xE6E1),True,30,xui.Color_White)
	ASTabStrip1.AddPage(xui.Color_ARGB(255,0, 174, 255),"Stat mois",Icon,"",tmp_xpnl,"")
	tmp_xpnl.LoadLayout("StatTempDay")
	LblLocStat.Text=Cockpit.Local_sensor
	
	
	
	DateTemplate.Initialize
	
	DateTemplate.Date = DateTime.Now
	'UpdateLabel
	Dialog.Initialize(Activity)
	Dim cs As CSBuilder
	Dialog.Title = cs.Initialize.Size(24).Append("Select Date").PopAll
	SetLightTheme
	
End Sub

Sub ASViewPager1_PageChanged(Index As Int)
	ASTabStrip1.ViewPager_PageChanged(Index)
End Sub

Sub ASTabMenu1_TabClick(index As Int)
	ASTabStrip1.TabMenu_TabClick(index)
End Sub

'*************Mise en forme du template Date****************
Sub SetLightTheme
	Dialog.TitleBarColor = 0xFF00AEFF
	Dialog.TitleBarHeight = 80dip
	Dim TextColor As Int = 0xFF5B5B5B
	Dialog.BackgroundColor = xui.Color_White
	Dialog.ButtonsColor = xui.Color_White
	Dialog.ButtonsTextColor = Dialog.TitleBarColor
	Dialog.BorderColor = xui.Color_Transparent
	DateTemplate.DaysInWeekColor = xui.Color_Black
	DateTemplate.SelectedColor = 0xFF39D7CE
	DateTemplate.HighlightedColor = 0xFF00CEFF
	DateTemplate.DaysInMonthColor = TextColor
	DateTemplate.lblMonth.TextColor = TextColor
	DateTemplate.lblYear.TextColor = TextColor
	DateTemplate.SelectedColor = 0xFF00CEFF
	
	For Each x As B4XView In Array(DateTemplate.btnMonthLeft, DateTemplate.btnMonthRight, DateTemplate.btnYearLeft, DateTemplate.btnYearRight)
		x.Color = xui.Color_Transparent
	Next
End Sub

'********************récupére la date d'analyse selectionnée ***************************
Private Sub BtnCalendar_Click
	Wait For (Dialog.ShowTemplate(DateTemplate, "", "", "CANCEL")) Complete (Result As Int)
	UpdateDateSelected
End Sub

Sub UpdateDateSelected
	'lblDate.Text = $"Selected Date: $Date{DateTemplate.Date}"$
	DateTime.DateFormat="dd MMM yyyy"
	
	Select ASViewPager1.CurrentIndex
		Case 0 'Day
			Log(DateTime.Date(DateTemplate.Date))
		Case 1 'Week
			isoGetWeekOfYear(DateTemplate.Date)
			Log(isoGetWeekOfYear(DateTemplate.Date))
		Case 2 'Month
			Log(DateTime.GetMonth(DateTemplate.Date))
	End Select
	
End Sub

'*************Extraction N° de semaine******************

Sub isoGetWeekOfYear(ticks As Long) As Int
	Dim offset As Int =  0
'	Dim locale As AHLocale
'	locale.Initialize
'	'locale.Initialize3("Fr","FR/FRA")
'	Log(locale.DisplayCountry)
'	Log(locale.DisplayLanguage)
'	Log(locale.Country)
'	Log(locale.FirstDayOfWeek)
	Dim FirstDay As Long  = DateUtils.SetDate(DateTime.GetYear(ticks), 1, 1)
	If DateTime.GetDayOfWeek(FirstDay) >5 Then ' is Thursday in Week?
		Do While(DateTime.GetDayOfWeek(FirstDay) <> 3) ' Find first Monday
			FirstDay=DateTime.Add (FirstDay,0,0,1)
			offset=offset-1
		Loop
	Else
		Do While(DateTime.GetDayOfWeek(FirstDay) <> 3) 'Find first Monday
			FirstDay=DateTime.Add (FirstDay,0,0,-1)
			offset=offset+1
		Loop
	End If
	Return Floor((DateTime.GetDayOfYear(ticks) + offset) / 7) +1
End Sub

'******************Création du graphique *********************
Private Sub CreateSingleLineChartData
	
	Dim listAnayser As List
	Dim str As StringFunctions
		
	Dim DateStart As String="10 févr. 2021" 'Filtre sur la date
	Dim Sensor As String = "58:2D:34:38:5C:55" 'Filtre sur le Sensor
	Dim GetInfo As Boolean=False
	
	Dim StatList As List
	StatList.Initialize
	StatList.Clear
	
		
	
	listAnayser.Initialize
	listAnayser.Clear
	str.Initialize
	
	For Each data As String In StatList
				
		Dim data_temp() As String= Regex.Split(";",data)
		
		If data_temp.Length=1 Then
			
			Dim S_Date As String= str.Left(data_temp(0),data_temp(0).Length-9)
			Dim S_Time As String= str.Right(data_temp(0),8)
			
			If DateStart=S_Date Then 'Date Start
				GetInfo=True
				'listAnayser.Add(S_Time)
			Else
				GetInfo=False
			End If
		End If
		
		If listAnayser.Size<>0 And GetInfo=False Then Exit
		If GetInfo=True And data_temp.Length>1 Then
			
			'identifie le sensor et stocke les valeurs Temp & Heure
			If data_temp(0)=Sensor Then
				listAnayser.Add(S_Time & ";" & data)
			End If
			
		End If
		
	Next
	
	
	
	' Initialize the single line data
	xChartSensor.ClearData
	
	xChartSensor.Title = "Single line graph"
	xChartSensor.XAxisName = "Day"
	xChartSensor.YAxisName = "Values"
	'    SingleLine1.YAxisName = ""
	'    SingleLine1.IncludeLegend = False
	xChartSensor.IncludeLegend = "BOTTOM"
	xChartSensor.AutomaticScale = True
	xChartSensor.YZeroAxis=False
	xChartSensor.XScaleTextOrientation = "VERTICAL"
	xChartSensor.AddLine("Test line", xui.Color_Blue)
  
'	Private vl As List= Array As Double(Rnd(0, 60),Rnd(0, 60),Rnd(0, 60),Rnd(0, 60),Rnd(0, 60),Rnd(0, 60),Rnd(0, 60),Rnd(0, 60),Rnd(0, 60),Rnd(0, 60),Rnd(0, 60))
	Try
		For Each data As String In listAnayser
			Dim data_chart() As String= Regex.Split(";",data)
			Dim Time_S As String=data_chart(0)
			Dim Temp_S As Double=data_chart(2)
			xChartSensor.AddLinePointData(Time_S, Temp_S,True)
		Next
	Catch
		Log(LastException)
	End Try
	
	
	
'	For i = 0 To vl.Size-1
'		SingleLine1.AddLineMultiplePoints(2005+i, Array As Double(vl.Get(i)),True)
'	Next
	xChartSensor.DrawChart
End Sub

Sub Activity_Resume

End Sub

Sub Activity_Pause (UserClosed As Boolean)

End Sub


Private Sub xChartSensor_Touch (X As Double, Y As Double)
	
End Sub

Private Sub xChartSensor_CursorTouch (Action As Int, CursorIndex As Int)
	
End Sub

Private Sub xChartHeat_Touch (X As Double, Y As Double)
	
End Sub

Private Sub xChartHeat_CursorTouch (Action As Int, CursorIndex As Int)
	
End Sub




Private Sub ASViewPager1_ScrollChanged(Offset As Int)
	
End Sub

Private Sub ASViewPager1_ReachEnd
	
End Sub

Private Sub ASViewPager1_TouchBegin
	
End Sub

Private Sub ASViewPager1_TouchEnd
	
End Sub

